<?php
/*
Plugin Name: Profilo
Plugin URI: http://familypress.net/profilo/
Description: Adds a gravatar and link to gravatar.com, plus fields for Twitter and Facebook usernames to the Profile page. Inspired by Twitter Profile Field (http://jayj.dk/twitter-profile-field/).
Author: Isaac Wedin
Version: 0.1
Author URI: http://familypress.net/
*/
// Copyright (c) 2009 Isaac Wedin. All rights reserved.
//
// Released under the GPL license
// http://www.opensource.org/licenses/gpl-license.php
// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// **********************************************************************

function profilo_display() {
   global $user_ID;
   if ( preg_match('&profile.php&', $_SERVER['REQUEST_URI'])) {
      $id = $user_ID;
   } elseif($_GET['user_id']) {
      $id = $_GET['user_id'];
   }
	$email = get_usermeta($id, 'user_email');
	$twitter = get_usermeta($id, 'twitter');
	$facebook = get_usermeta($id, 'facebook');
	$author_url = get_author_posts_url($id);
	echo "<h3>Your avatar</h3>\n";
	echo "<p>" . get_avatar($email, '60') . "</p>\n";
	echo "<p>To change your avatar, go to <a href='http://gravatar.com/'>gravatar.com</a>, a free service that links an avatar to an email address. Keep in mind that your avatar is linked to the email address on your profile here, so that address needs to be on your gravatar account. Changes to your gravatar can take a little while to go through, but if the delay seems too long check your gravatar rating because we only display G-rated avatars here.</p>\n";
	echo "<h3>Twitter and Facebook</h3>\n";
	echo "<p>Enter your Twitter and/or Facebook usernames if you would like links added to your public author page, along with your website. Your usernames may be used to add links to <a href='" . $author_url . "'>your author page</a> at this site, so do not enter them if you do not wish to share them.</p>\n";
	echo '<table class="form-table">
    <tr>
        <th><label for="twitter">Twitter username</label></th>
        <td><input type="text" name="twitter" id="twitter" value="' . $twitter . '" class="regular-text" />
        </td>
    </tr>
    <tr>
        <th><label for="facebook">Facebook username</label></th>
        <td><input type="text" name="facebook" id="facebook" value="' . $facebook . '" class="regular-text" />
        </td>
    </tr>
    </table>';
}

function profilo_save() {
	global $user_ID;
	if (preg_match('&profile.php&', $_SERVER['REQUEST_URI'])) {
		$id = $user_ID;
	} elseif($_GET['user_id']) {
		$id = $_GET['user_id'];
	}
	if (isset ($_POST['twitter']) && !empty($_POST['twitter'])) {
		$twpos = strpos($_POST['twitter'], '/');
		if ($twpos !== false) {
			$twitter = esc_url(trim($_POST['twitter']));
		} else {
			$twitter = esc_html(trim($_POST['twitter']));
		}
		update_usermeta($id, 'twitter', $twitter);
	}
	if (isset ($_POST['facebook']) && !empty($_POST['facebook'])) {
		$fbpos = strpos($_POST['facebook'], '/');
		if ($fbpos !== false) {
			$facebook = esc_url(trim($_POST['facebook']));
		} else {
			$facebook = esc_html(trim($_POST['facebook']));
		}
		update_usermeta($id, 'facebook', $facebook);
	}
}


add_filter('show_user_profile', 'profilo_display');
add_action('edit_user_profile', 'profilo_display');
add_action('profile_update', 'profilo_save');

?>
